/********************************************************************************
  $Header: /home/farin/cvs/libvideocoding/libvideocoding/datatypes/dct.hh,v 1.4 2002/05/09 22:00:31 farin Exp $

    Data-structures to hold the coefficients of an 8x8-DCT block and for
    quantization matrices.
 ********************************************************************************
    Copyright (C) 2000 Dirk Farin (see the README for complete list of authors)

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef LIBVIDEOCODING_DATATYPES_DCT_HH
#define LIBVIDEOCODING_DATATYPES_DCT_HH

#include <libvideogfx/types.hh>
#include <iostream>

namespace videocoding {
  using namespace videogfx;

  struct DCTBlock_8x8
  {
    DCTBlock_8x8() : may_contain_data(true) { }

    short coeff[8 /* v (vertical) */][8 /* u (horizontal) */];

    bool  may_contain_data;  // if false -> coeff[][]==0

    void Clear();

    bool operator==(const DCTBlock_8x8& blk) const;
    bool operator!=(const DCTBlock_8x8& blk) const;
    bool IsAllZero() const;
    bool IsInRange(int low,int high) const;
    bool IsACInRange(int low,int high) const;
  };


  struct QMatrix_8x8
  {
    uint8 mat[8 /* v (vertical) */][8 /* u (horizontal) */];

    bool operator==(const QMatrix_8x8&) const;
    bool operator!=(const QMatrix_8x8&) const;
  };

  std::ostream& operator<<(std::ostream&,const DCTBlock_8x8&);
  std::ostream& operator<<(std::ostream&,const QMatrix_8x8&);
}

#endif
